%{
	#include "parse.h"
	#include "simbolos.h"

	#define YYSTYPE token_t

	#include "y.tab.h"

	#define PPO_REGLA

	/* Variable global para contar lineas */
	int linea = 1;
%}

%option noyywrap

DIGIT	[0-9]
LETTER	[a-zA-Z]
ALPHA	[a-zA-Z0-9]

%%

begin			PPO_REGLA; return T_BEGIN;
end			PPO_REGLA; return T_END;
bool			PPO_REGLA; return T_BOOL;
int			PPO_REGLA; return T_INT;
ref			PPO_REGLA; return T_REF;
function		PPO_REGLA; return T_FUNCTION;
return			PPO_REGLA; return T_RETURN;
if			PPO_REGLA; return T_IF;
then			PPO_REGLA; return T_THEN;
fi			PPO_REGLA; return T_FI;
else			PPO_REGLA; return T_ELSE;
repeat			PPO_REGLA; return T_REPEAT;
until			PPO_REGLA; return T_UNTIL;
input			PPO_REGLA; return T_INPUT;
output			PPO_REGLA; return T_OUTPUT;
deref			PPO_REGLA; return T_DEREF;
true			PPO_REGLA; return T_TRUE;
false			PPO_REGLA; return T_FALSE;

"("			PPO_REGLA; return T_PARENTESIS_I;
")"			PPO_REGLA; return T_PARENTESIS_D;
";"			PPO_REGLA; return T_PUNTOCOMA;
","			PPO_REGLA; return T_COMA;
"+"			PPO_REGLA; return T_OPERADOR_SUMA;
"-"			PPO_REGLA; return T_OPERADOR_RESTA;
"*"			PPO_REGLA; return T_OPERADOR_MULT;
"="			PPO_REGLA; return T_OPERADOR_IGUAL;
">="			PPO_REGLA; return T_OPERADOR_MAYOR_IGUAL;
">"			PPO_REGLA; return T_OPERADOR_MAYOR;
"<="			PPO_REGLA; return T_OPERADOR_MENOR_IGUAL;
"<"			PPO_REGLA; return T_OPERADOR_MENOR;
"!="			PPO_REGLA; return T_OPERADOR_DESIGUAL;
":="			PPO_REGLA; return T_OPERADOR_ASIGNACION;

{DIGIT}+		{
				PPO_REGLA;
				yylval.valor = strtol(yytext, 0, BASE);
				return T_NUMBER;
			}
{LETTER}{ALPHA}*	{
				PPO_REGLA;
				yylval.clave = yytext;
				return T_ID;
			}

"#"[^\n]*		/* comentarios */
[ \t]+			/* blancos */
"\n"			linea ++;
.			error_lexico(yytext);

%%
