/*
 * Definiciones para la tabla hash.
 */
#ifndef __hash_h_
# define __hash_h_	1

typedef int hash_posicion_t;
typedef hash_posicion_t (*hash_funcion_t)
	(void *clave, int tamano_clave, int intento);

typedef struct hash_elemento_s {
	void *valor;
	void *clave;
	int tamano_clave;
} hash_elemento_t;

typedef struct hash_s {
	int tamano;
	hash_elemento_t *tabla;
	hash_funcion_t funcion;
} hash_t;

int hash_crear(hash_t *tabla, int tamano);
int hash_liberar(hash_t *tabla);
int hash_liberar_claves(hash_t *tabla);
int hash_insertar(hash_t *tabla, hash_elemento_t *elemento);
hash_elemento_t *hash_buscar(hash_t *tabla, void *clave, int tamano_clave);

#endif /* __hash_h_ */
