/*
 * Implementacion de la pila.
 */
#include <stdlib.h>

#include "pila.h"

int pila_crear(pila_t *pila) {
	pila->cabeza = 0;
	return 1;
}

int pila_liberar(pila_t *pila) {
	while (pila->cabeza)
		if (!pila_pop(pila))
			return 0;
	return 1;
}

int pila_push(pila_t *pila, const void *valor0, const void *valor1) {
	pila_elemento_t *nuevo = malloc(sizeof(pila_elemento_t));
	if (!nuevo)
		return 0;
	nuevo->siguiente = pila->cabeza;
	nuevo->valor0 = (void *) valor0;
	nuevo->valor1 = (void *) valor1;
	pila->cabeza = nuevo;
	return 1;
}

int pila_pop(pila_t *pila) {
	pila_elemento_t *tmp = pila->cabeza;
	if (!tmp)
		return 0;
	pila->cabeza = tmp->siguiente;
	free(tmp);
	return 1;
}

void *pila_top(const pila_t *pila) {
	if (!pila->cabeza)
		return 0;

	return pila->cabeza->valor0;
}
