/*
 * Definiciones para la tabla de simbolos.
 */
#ifndef __tabla_h_
# define __tabla_h_	1

# include "hash.h"
# include "pila.h"

# define TAMANO_TABLA	8192 /* 2 ^ 13 - 13 es primo */

typedef struct tabla_simbolos_s {
	hash_t principal;
	pila_t ambitos;
} tabla_simbolos_t;

int tabla_crear(tabla_simbolos_t *tabla);
int tabla_liberar(tabla_simbolos_t *tabla);
int tabla_insertar(tabla_simbolos_t *tabla, char *elemento, void *valor);
void *tabla_buscar(tabla_simbolos_t *tabla, char *elemento, char **amb);
int tabla_abrir(tabla_simbolos_t *tabla, char *ambito);
int tabla_cerrar(tabla_simbolos_t *tabla);

#endif /* __tabla_h_ */
